--============================================================================--
-- int86.e e-mail: hayden_mckay@hotmail.com

-- bypasses the protected mode interrupt handlers by useing int api's provided
-- with the causeway extender by michael divore. search www.devoresoftware.com
-- for more infomation about features supplied with the dpmi causeway extender

-- [ functions ]    -   int86(??h,regs) --  simulate interrupts
--                  -   int86(00h,regs) --  simulate a far call

--                  -   cs:ip ignored for dos interrupts
--                  -   cs:ip point to code for far call
--                  -   ss:sp is handled by the causeway

--                  -   note. causeway provides a 16-bit 1024 byte
--                  -         stack frame for calls made via cs:ip

include dll.e
include memory.e

global
constant

    REGS_EDI   =   #1,      REGS_DI = REGS_EDI,
    REGS_ESI   =   #2,      REGS_SI = REGS_ESI,
    REGS_EBP   =   #3,      REGS_BP = REGS_EBP,
--  REGS_ESP   =   #4,      REGS_SP = REGS_ESP, --  reserved by causeway
    REGS_EBX   =   #5,      REGS_BX = REGS_EBX,
    REGS_EDX   =   #6,      REGS_DX = REGS_EDX,
    REGS_ECX   =   #7,      REGS_CX = REGS_ECX,
    REGS_EAX   =   #8,      REGS_AX = REGS_EAX,
    REGS_FLAGS =   #9,
    REGS_ES    =   #A,
    REGS_DS    =   #B,
    REGS_FS    =   #C,
    REGS_GS    =   #D,
    REGS_IP    =   #E,
    REGS_CS    =   #F
--  REGS_SP    =   10h                          --  handled by causeway
--  REGS_SS    =   11h                          --  handled by causeway

sequence
intxx_code
intxx_code={
#55,#89,#E5,#57,#56,#53,#52,#8B,#5D,#08,#89,#EE,#89,#EF,#83,#C6,#2C,#83,#C7,#2C,
#BA,#07,#00,#00,#00,#66,#A5,#83,#C6,#02,#83,#EA,#01,#75,#F6,#83,#EF,#2E,#89,#FE,
#B8,#01,#FF,#00,#00,#83,#FB,#00,#75,#03,#83,#C0,#01,#CD,#31,#BF,#00,#00,#00,#00,
#A5,#A5,#A5,#A5,#A5,#A5,#A5,#A5,#BA,#07,#00,#00,#00,#B8,#FF,#FF,#00,#00,#A5,#21,
#47,#FC,#83,#EE,#02,#83,#EA,#01,#75,#F4,#5A,#5B,#5E,#5F,#89,#EC,#5D,#C3}

sequence params
params={#02000001}
params&=repeat(#02000004,8)
params&=repeat(#02000002,7)

atom code code=align(98,4) poke(code,intxx_code)
atom data data=align(60,4) poke4(code+56,data)
constant intxx=define_c_proc({},code,params)

type int(atom x) return x>=0 and x<=255  end type     -- interrupt type
type reg(sequence x) return length(x)=15 end type     -- registers type

global function int86(int int_no,reg reg_rm)

    c_proc(intxx,int_no&reg_rm)
    reg_rm=peek4u({data,15})

    return reg_rm
    
end function

--============================================================================--

